<?php
require_once 'database_functions.php';
require_once 'Alliance.php';
require_once 'Event.php';
require_once 'Planet.php';
require_once 'Player.php';
require_once 'IDatabaseDao.php';

/*
MySQL implementation of the database DAO.
*/
class MySqlDatabaseDao implements IDatabaseDao{
  private $con;
  
  public function MySqlDatabaseDao($host, $username, $password, $db){
    $this->con = mysql_connect($host, $username, $password);
    if (!$this->con){
      die('Could not connect: ' + mysql_error());
    }
    mysql_select_db($db, $this->con);
  }
  
  public function close(){
    mysql_close($this->con);
  }
  
  public function begin(){
    _mysql_query("begin");
  }
  
  public function commit(){
    _mysql_query("commit");
  }
  
  public function rollback(){
    _mysql_query("rollback");
  }
  
  public function getAlreadyImportedFilesDates(){
    $imported_data_files = array();
    
    $result = _mysql_query("select date from imported_files");
    while ($row = mysql_fetch_row($result)){
      $imported_data_files[] = str_replace('-', '', $row[0]);
    }
    mysql_free_result($result);
    
    return $imported_data_files;
  }
  
  public function addPlayerData($player, $imported_file_id){
    //insert persistent planet data if none exists
    $id = $this->getPlayerId($player->name);
    if ($id == null){
      $query = sprintf("insert into players (name, location) values ('%s', '%s')", mysql_real_escape_string($player->name), mysql_real_escape_string($player->location));
      _mysql_query($query);
      $id = mysql_insert_id();
    } else {
      $query = sprintf("update players set name = '%s', location = '%s' where id = %d", mysql_real_escape_string($player->name), mysql_real_escape_string($player->location), $id);
      _mysql_query($query);
    }
    
    //insert history
    $query = sprintf(
      "insert into player_histories (player_id, imported_file_id, influ_rank, influ_rank_sc, influ_score, hyp_rank, idr_rank, idr_score, idr_rank_sc, sc)
      values (%d, %d, %d, %d, %d, %d, %d, %d, %d, %d)",
      $id, $imported_file_id, $player->influ_rank, $player->influ_rank_sc, $player->influ_score, $player->hyp_rank, $player->idr_rank, $player->idr_score, $player->idr_rank_sc, $player->sc);
    _mysql_query($query);
    
    return $id;
  }
  
  public function addPlanetData($planet, $imported_file_id){
    //insert persistent planet data if none exists
    $id = $this->getPlanetId($planet->hyp_id);
    if ($id == null){
      $query = sprintf("insert into planets (hyp_id, race, prod_type) values (%d, %d, %d)", $planet->hyp_id, $planet->race, $planet->prod_type);
      _mysql_query($query);
      $id = mysql_insert_id();
    } else {
      $query = sprintf("update planets set hyp_id = %d, race = %d, prod_type = %d where id = %d", $planet->hyp_id, $planet->race, $planet->prod_type, $id);
      _mysql_query($query);
    }
    
    //insert history
    $public_tag = 'null';
    if ($planet->public_tag != null){
      $public_tag = $this->getAllianceId($planet->public_tag);
      if ($public_tag == null){
        $public_tag = $this->addAllianceStub($planet->public_tag);
      }
    }

    $query = sprintf(
      "insert into planet_histories (planet_id, imported_file_id, name, x, y, gov_system, activity, alliance_id, civ_level, planet_size)
      values (%d, %d, '%s', %d, %d, %d, %d, %s, %d, %d)",
      $id, $imported_file_id, mysql_real_escape_string($planet->name), $planet->x, $planet->y, $planet->gov_system, $planet->activity, $public_tag, $planet->civ_level, $planet->planet_size);
      _mysql_query($query);
    
    return $id;
  }
  
  public function addAllianceData($alliance, $imported_file_id){
    //insert persistent planet data if none exists
    $id = $this->getAllianceId($alliance->tag);
    if ($id == null){
      $query = sprintf("insert into alliances (name, tag, description) values ('%s', '%s', '%s')", mysql_real_escape_string($alliance->name), mysql_real_escape_string($alliance->tag), mysql_real_escape_string($alliance->description));
      _mysql_query($query);
      $id = mysql_insert_id();
    } else {
      $query = sprintf("update alliances set name = '%s', tag = '%s', description = '%s' where id = %d", mysql_real_escape_string($alliance->name), mysql_real_escape_string($alliance->tag), mysql_real_escape_string($alliance->description), $id);
      _mysql_query($query);
    }
    
    //insert history
    $query = sprintf(
      "insert into alliance_histories (alliance_id, imported_file_id, president_id, avg_x, avg_y, nb_planets, total_influence)
      values (%d, %d, %d, %d, %d, %d, %d)",
      $id, $imported_file_id, $this->getPlayerId($alliance->president), $alliance->avg_x, $alliance->avg_y, $alliance->nb_planets, $alliance->total_influence);
    _mysql_query($query);
    
    return $id;
  }
  
  public function addEventData($event, $imported_file_id){
    $id = null;
    
    $hash = md5($event->planet_hyp_id . $event->date . $event->description);
    
    $query = sprintf(
      "select id from events where hash = '%s'",
      $hash);   
    $result = _mysql_query($query);
    if ($row = mysql_fetch_row($result)){
      $id = $row[0];
    } else {
      $query = sprintf(
        "insert into events (planet_id, imported_file_id, date, description, hash)
        values (%d, %d, '%s', '%s', '%s')",
        $this->getPlanetId($event->planet_hyp_id), $imported_file_id, mysql_real_escape_string($event->date), mysql_real_escape_string($event->description), $hash);
      _mysql_query($query);
      $id = mysql_insert_id();
    }
    mysql_free_result($result);
    
    return $id;
  }
  
  public function addImportedFile($date){
    $query = sprintf(
      "insert into imported_files (date)
      values ('%s')",
      $date);
    _mysql_query($query);
    return mysql_insert_id();
  }
  
  /*
  Gets the database ID of the given alliance.
  $tag = the alliance's tag
  returns: the database ID or null if none found
  */
  private function getAllianceId($tag){
    $id = null;
    
    $query = sprintf("select id from alliances where tag = '%s'", mysql_real_escape_string($tag));
    $result = _mysql_query($query);
    if ($row = mysql_fetch_row($result)){
      $id = $row[0];
    }
    mysql_free_result($result); 
    
    return $id;
  }

  /*
  Gets the database ID of the given player.
  $name = the player's name
  returns: the database ID or null if none found
  */
  private function getPlayerId($name){
    $id = null;
    $query = sprintf("select id from players where name = '%s'", mysql_real_escape_string($name));
    $result = _mysql_query($query);
    if ($row = mysql_fetch_row($result)){
      $id = $row[0];
    }
    mysql_free_result($result);
    return $id;
  }
  
  /*
  Gets the database ID of the given planet.
  $hyp_id = Hyperium's ID for the planet
  returns: the database ID or null if none found
  */
  private function getPlanetId($hyp_id){
    $id = null;
    $query = sprintf("select id from planets where hyp_id = %d", $hyp_id);
    $result = _mysql_query($query);
    if ($row = mysql_fetch_row($result)){
      $id = $row[0];
    }
    mysql_free_result($result);
    return $id;
  }
  
  /*
  Adds basic info of an alliance to the database.  This assumes that the given alliance does not already exist in the database.
  $tag = the alliance's tag
  returns: the database ID of the newly added record
  */
  private function addAllianceStub($tag){
    $query = sprintf("insert into alliances (name, tag, description) values ('%s', '%s', '')", mysql_real_escape_string($tag), mysql_real_escape_string($tag));
    _mysql_query($query);
    return mysql_insert_id();
  }
}
?>
