<?php
/*
Downloads all the data files from all actively running games.
$username = your Hyperiums user name
$password = your Hyperiums password
$dir = the directory to download the data files to
*/
function main($username, $password, $dir){
  if (!file_exists($dir) && !mkdir($dir)){
    die("Cannot create '$dir' directory.");
  }
  
  $url = "http://www.hyperiums.com/servlet/HAPI?game=%s&player=$username&passwd=$password&request=download&filetype=%s";
  $filepath = dirname(__FILE__) . "/$dir/%s-%s-%s.txt.gz";
  $filetypes = array('alliances', 'events', 'planets', 'players');
  $today = date('Ymd');
  
  //get list of all games
  $games = getAllGames(file_get_contents('http://www.hyperiums.com/servlet/HAPI?request=games'));
  
  foreach ($games as $game){
    foreach ($filetypes as $filetype){
      $f = sprintf($filepath, $game, $today, $filetype);
      echo "getting $f...";
      $u = sprintf($url, $game, $filetype);
      $contents = file_get_contents($u);
      if ($contents == ''){
        echo "error.\n";
      }
      else if (substr($contents, 0, 5) == 'error'){
        echo $contents;
      }
      else {
        $fpWrite = fopen($f, 'w');
        fwrite($fpWrite, $contents);
        fclose($fpWrite);
        echo "done.\n";
      }
    }
  }
}

/*
Gets a list of all running Hyperiums games.
$response = the response to a HAPI request for info on all games
returns: an array of the names of all running games
*/
function getAllGames($response){
  //get each game name and its state
  preg_match_all("/game[0-9]+=([^&]+)/", $response, $names);
  $names = $names[1];
  preg_match_all("/state[0-9]+=([^&]+)/", $response, $states);
  $states = $states[1];
  
  $games = array();
  for ($i = 0; $i < count($states); $i++){
    $s = $states[$i];
    if ($s == 0 || $s == 1){
      /*
      -1: not running, closed
       0: running, closed
       1: running, open
       2: not running yet, but open to registration
      */
      //we only care about running games
      $games[] = $names[$i];
    }
  }
  
  return $games;
}

?>
