<?php
require_once 'PHPUnit/Framework.php';
require_once '../Alliance.php';

/*
Tests the Alliance class.
*/
class AllianceTest extends PHPUnit_Framework_TestCase{
  public function testWithDescription(){
    $alliance = new Alliance(array('-TKC- The Killer Crabs', 'Troll / -FK- / commando', 'Badlol 5 -4 2 2'));
    $this->assertEquals('-TKC-', $alliance->tag);
    $this->assertEquals('The Killer Crabs', $alliance->name);
    $this->assertEquals('Troll / -FK- / commando', $alliance->description);
    $this->assertEquals('Badlol', $alliance->president);
    $this->assertEquals(5, $alliance->avg_x);
    $this->assertEquals(-4, $alliance->avg_y);
    $this->assertEquals(2, $alliance->nb_planets);
    $this->assertEquals(2, $alliance->total_influence);
  }
  
  public function testWithoutDescription(){
    $alliance = new Alliance(array('-TKC- The Killer Crabs', '', 'Badlol 5 -4 2 2'));
    $this->assertEquals('-TKC-', $alliance->tag);
    $this->assertEquals('The Killer Crabs', $alliance->name);
    $this->assertEquals('', $alliance->description);
    $this->assertEquals('Badlol', $alliance->president);
    $this->assertEquals(5, $alliance->avg_x);
    $this->assertEquals(-4, $alliance->avg_y);
    $this->assertEquals(2, $alliance->nb_planets);
    $this->assertEquals(2, $alliance->total_influence);
  }
}
?>
