<?php
require_once 'PHPUnit/Framework.php';
require_once '../database_functions.php';
require_once '../DataFileGroup.php';

/*
Tests the DataFileGroup class and related functions.
*/
class DataFileGroupTest extends PHPUnit_Framework_TestCase{
  private $files = array('Hyperiums6-20070410-planets.txt.gz', 'Hyperiums6-20070410-players.txt.gz', 'Hyperiums6-20070410-alliances.txt.gz', 'Hyperiums6-20070410-events.txt.gz', 'Hyperiums6-20070411-events.txt.gz', 'foobar.txt');
  
  protected function setUp(){
    foreach ($this->files as $f){
      touch($f);
    }
  }
  
  protected function tearDown(){
    foreach ($this->files as $f){
      unlink($f);
    }
  }
  
  public function testGetDataFileGroups(){    
    $scanned = getDataFileGroups('Hyperiums6', './');
    
    $this->assertEquals('./Hyperiums6-20070410-planets.txt.gz', $scanned['20070410']->planets);
    $this->assertEquals('./Hyperiums6-20070410-players.txt.gz', $scanned['20070410']->players);
    $this->assertEquals('./Hyperiums6-20070410-alliances.txt.gz', $scanned['20070410']->alliances);
    $this->assertEquals('./Hyperiums6-20070410-events.txt.gz', $scanned['20070410']->events);
    
    $this->assertEquals(null, $scanned['20070411']->planets);
    $this->assertEquals(null, $scanned['20070411']->players);
    $this->assertEquals(null, $scanned['20070411']->alliances);
    $this->assertEquals('./Hyperiums6-20070411-events.txt.gz', $scanned['20070411']->events);

    $this->assertEquals(isset($scanned['20070412']), false);
  }
}
?>