<?php
require_once 'PHPUnit/Framework.php';

/*
Base class used for all database-related tests.  A MySQL database must already be running for this test to work.
*/
class DatabaseTestBase extends PHPUnit_Framework_TestCase{
  protected $username = 'root', $password = 'root', $db = 'hyperiums_test', $host = ':/tmp/mysql.sock', $schema = '../schema.sql';
  
  /*
  Used for testing the value of a column in a row, also tests to see if the given column name exists.
  */
  protected function assertColumn($expected_value, $column_name, $row){
    if ($expected_value != null && !isset($row[$column_name])){
      $this->fail("column '$column_name' doesn't exist");
    }
    $this->assertEquals($expected_value, $row[$column_name]);
  }
  
  /*
  Creates a new database just for this test.
  */
  protected function initDatabase(){
    $output = shell_exec("echo \"drop database if exists $this->db;create database $this->db;use $this->db;\n`cat $this->schema`\" | mysql -u$this->username -p$this->password");
  }
}
?>
