<?php
require_once 'PHPUnit/Framework.php';
require_once '../download_functions.php';

/*
Tests download-related functionality.
*/
class DownloadTest extends PHPUnit_Framework_TestCase{
  public function testGetAllGames(){
    //all active games
    $games = getAllGames("dummy=&game0=Hyperiums6&state0=1&descr0=Permanent game (Round #6)&length0=replaced_by_maxenddate&maxenddate0=null&ispeec0=0&maxplanets0=14&initcash0=500000&maxofferedplanets0=15&nextplanetdelay0=5&game1=HyperiumsRLF&state1=1&descr1=Permanent RLF game (Real Life Friendly)&length1=replaced_by_maxenddate&maxenddate1=null&ispeec1=0&maxplanets1=14&initcash1=300000&maxofferedplanets1=10&nextplanetdelay1=5&game2=Galaxy_V5_7&state2=1&descr2=Summer game 2009&length2=replaced_by_maxenddate&maxenddate2=2009-09-19&ispeec2=0&maxplanets2=14&initcash2=500000&maxofferedplanets2=6&nextplanetdelay2=5");
    $this->assertEquals(3, count($games));
    $i = 0;
    $this->assertEquals('Hyperiums6', $games[$i++]);
    $this->assertEquals('HyperiumsRLF', $games[$i++]);
    $this->assertEquals('Galaxy_V5_7', $games[$i++]);
    
    //only one active game
    $games = getAllGames("dummy=&game0=Hyperiums6&state0=1&descr0=Permanent game (Round #6)&length0=replaced_by_maxenddate&maxenddate0=null&ispeec0=0&maxplanets0=14&initcash0=500000&maxofferedplanets0=15&nextplanetdelay0=5&game1=HyperiumsRLF&state1=-1&descr1=Permanent RLF game (Real Life Friendly)&length1=replaced_by_maxenddate&maxenddate1=null&ispeec1=0&maxplanets1=14&initcash1=300000&maxofferedplanets1=10&nextplanetdelay1=5&game2=Galaxy_V5_7&state2=2&descr2=Summer game 2009&length2=replaced_by_maxenddate&maxenddate2=2009-09-19&ispeec2=0&maxplanets2=14&initcash2=500000&maxofferedplanets2=6&nextplanetdelay2=5");
    $this->assertEquals(1, count($games));
    $i = 0;
    $this->assertEquals('Hyperiums6', $games[$i++]);
  }
}