<?php
require_once 'DatabaseTestBase.php';
require_once '../database_functions.php';

/*
Tests the parsing and importing of data files.  The database must already be running for this test to work.
*/
class MainTest extends DatabaseTestBase{
  protected function tearDown(){
    $con = mysql_connect($this->host, $this->username, $this->password);
    if (!$con){
      die('Could not connect: ' + mysql_error());
    }
    mysql_query("drop database $this->db");
    mysql_close($con);
  }
  
  public function test(){
    $this->initDatabase();
    
    //run it
    main('.', $this->host, $this->username, $this->password, $this->db, 'Hyperiums6');
    $con = mysql_connect($this->host, $this->username, $this->password);
    if (!$con){
      die('Could not connect: ' + mysql_error());
    }
    mysql_select_db($this->db, $con);
    $this->_testImportedFileList();
    $this->_testPlayers();
    $this->_testAlliances();
    $this->_testPlanets();
    $this->_testEvents();
    mysql_close($con);
    
    //when running it again, it should see that it already imported the data files...
    //...and it should not add anything else to the database
    main('.', $this->host, $this->username, $this->password, $this->db, 'Hyperiums6');
    $con = mysql_connect($this->host, $this->username, $this->password);
    if (!$con){
      die('Could not connect: ' + mysql_error());
    }
    mysql_select_db($this->db, $con);
    $this->_testImportedFileList();
    $this->_testPlayers();
    $this->_testAlliances();
    $this->_testPlanets();
    $this->_testEvents();
  }
  
  private function _testImportedFileList(){
    $result = mysql_query('select * from imported_files order by date');
    $this->assertEquals(2, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn('2009-04-18', 'date', $row);
    $row = mysql_fetch_array($result);
    $this->assertColumn('2009-04-19', 'date', $row);
    mysql_free_result($result);
  }
  
  private function _testPlayers(){
    //test counts
    $result = mysql_query('select count(*) from players');
    $row = mysql_fetch_array($result);
    $this->assertEquals(true, 1714 <= $row[0]);
    mysql_free_result($result);
    $result = mysql_query('select count(*) from player_histories');
    $row = mysql_fetch_array($result);
    $this->assertEquals(true, 1714 <= $row[0]);
    mysql_free_result($result);
    
    //MacDaddy 21 20 14864322 1 43 96179 43 0 derby/england
    //MacDaddy 20 19 18169402 1 60 99470 60 0 derby/england
    $result = mysql_query("select * from players where name = 'MacDaddy'"); 
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $id = $row['id'];
    $this->assertColumn('MacDaddy', 'name', $row);
    $this->assertColumn('derby/england', 'location', $row);
    mysql_free_result($result);
    
    $result = mysql_query("select * from player_histories where player_id = $id order by imported_file_id");
    $this->assertEquals(2, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($id, 'player_id', $row);
    $this->assertColumn(21, 'influ_rank', $row);
    $this->assertColumn(20, 'influ_rank_sc', $row);
    $this->assertColumn(14864322, 'influ_score', $row);
    $this->assertColumn(1, 'hyp_rank', $row);
    $this->assertColumn(43, 'idr_rank', $row);
    $this->assertColumn(96179, 'idr_score', $row);
    $this->assertColumn(43, 'idr_rank_sc', $row);
    $this->assertColumn(0, 'sc', $row);
    $row = mysql_fetch_array($result);
    $this->assertColumn($id, 'player_id', $row);
    $this->assertColumn(20, 'influ_rank', $row);
    $this->assertColumn(19, 'influ_rank_sc', $row);
    $this->assertColumn(18169402, 'influ_score', $row);
    $this->assertColumn(1, 'hyp_rank', $row);
    $this->assertColumn(60, 'idr_rank', $row);
    $this->assertColumn(99470, 'idr_score', $row);
    $this->assertColumn(60, 'idr_rank_sc', $row);
    $this->assertColumn(0, 'sc', $row);
    mysql_free_result($result);
    
    //make sure the player in the 20090417 file didn't get added
    $result = mysql_query("select * from players where name = 'DontAddMe'");
    $this->assertEquals(0, mysql_num_rows($result));
    mysql_free_result($result);
  }
  
  private function _testAlliances(){
    //test counts
    $result = mysql_query('select count(*) from alliances');
    $row = mysql_fetch_array($result);
    $this->assertEquals(true, 109 <= $row[0]); //some planets are tagged with alliances that don't exist in the alliances data file
    mysql_free_result($result);
    $result = mysql_query('select count(*) from alliance_histories');
    $row = mysql_fetch_array($result);
    $this->assertEquals(true, 109 <= $row[0]);
    mysql_free_result($result);
    
    /*
    -HH- - Hevens Halos -
    
    DaPlagueIam -1 -1 30 413384
    */
    /*
    -HH- - Hevens Halos -
    
    DaPlagueIam -1 -3 35 576820
    */
    $result = mysql_query("select * from alliances where tag = '-HH-'"); 
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $alliance_id = $row['id'];
    $this->assertColumn('-HH-', 'tag', $row);
    $this->assertColumn('- Hevens Halos -', 'name', $row);
    $this->assertColumn('', 'description', $row);
    mysql_free_result($result);
    
    $result = mysql_query("select id from players where name = 'DaPlagueIam'");
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $president_id = $row[0];
    mysql_free_result($result);
    
    $result = mysql_query("select * from alliance_histories where alliance_id = $alliance_id order by imported_file_id");
    $this->assertEquals(2, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($president_id, 'president_id', $row);
    $this->assertColumn(-1, 'avg_x', $row);
    $this->assertColumn(-1, 'avg_y', $row);
    $this->assertColumn(30, 'nb_planets', $row);
    $this->assertColumn(413384, 'total_influence', $row);
    $row = mysql_fetch_array($result);
    $this->assertColumn($president_id, 'president_id', $row);
    $this->assertColumn(-1, 'avg_x', $row);
    $this->assertColumn(-3, 'avg_y', $row);
    $this->assertColumn(35, 'nb_planets', $row);
    $this->assertColumn(576820, 'total_influence', $row);
    mysql_free_result($result);
  }
  
  private function _testPlanets(){
    //test counts
    $result = mysql_query('select count(*) from planets');
    $row = mysql_fetch_array($result);
    $this->assertEquals(true, 6896 <= $row[0]);
    mysql_free_result($result);
    $result = mysql_query('select count(*) from planet_histories');
    $row = mysql_fetch_array($result);
    $this->assertEquals(true, 6896 <= $row[0]);
    mysql_free_result($result);
    
    //1943 HyperTension 0 -13 -8 2 2 15602 [] 1 2
    //1943 HyperTension 0 -13 -8 2 2 15602 [] 1 2
    $result = mysql_query("select * from planets where hyp_id = 1943"); 
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $planet_id = $row['id'];
    $this->assertColumn(1943, 'hyp_id', $row);
    $this->assertColumn(2, 'race', $row);
    $this->assertColumn(2, 'prod_type', $row);
    mysql_free_result($result);
    
    $result = mysql_query("select * from planet_histories where planet_id = $planet_id");
    $this->assertEquals(2, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn('HyperTension', 'name', $row);
    $this->assertColumn(-13, 'x', $row);
    $this->assertColumn(-8, 'y', $row);
    $this->assertColumn(0, 'gov_system', $row);
    $this->assertColumn(15602, 'activity', $row);
    $this->assertColumn(null, 'alliance_id', $row);
    $this->assertColumn(1, 'civ_level', $row);
    $this->assertColumn(2, 'planet_size', $row);
    $row = mysql_fetch_array($result);
    $this->assertColumn('HyperTension', 'name', $row);
    $this->assertColumn(-13, 'x', $row);
    $this->assertColumn(-8, 'y', $row);
    $this->assertColumn(0, 'gov_system', $row);
    $this->assertColumn(15602, 'activity', $row);
    $this->assertColumn(null, 'alliance_id', $row);
    $this->assertColumn(1, 'civ_level', $row);
    $this->assertColumn(2, 'planet_size', $row);
    mysql_free_result($result);
  }
  
  private function _testEvents(){
    //test counts
    $result = mysql_query('select count(*) from events');
    $row = mysql_fetch_array($result);
    $this->assertEquals(true, 4514 < $row[0]);
    mysql_free_result($result);
    
    //626 HBegins 2009-04-10 07:56:59 The government system has changed to Democratic.
    //626 HBegins 2009-04-10 08:27:24 Public alliance tag set to [<b>TRoLL</b>]
    //626 HBegins 2009-04-10 10:29:59 End of battle.
    //626 HBegins 2009-04-10 11:49:57 A battle has started.
    //626 HBegins 2009-04-10 12:29:58 End of battle.
    //626 HBegins 2009-04-10 22:39:11 A battle has started.
    //626 HBegins 2009-04-11 06:50:05 The planet owner has changed.
    //626 HBegins 2009-04-11 07:00:17 Public alliance tag set to [<b>-FK-</b>]
    //626 HBegins 2009-04-11 08:30:02 End of battle.
    $row_values = array(
      '2009-04-10 07:56:59 The government system has changed to Democratic.',
      '2009-04-10 08:27:24 Public alliance tag set to [<b>TRoLL</b>]',
      '2009-04-10 10:29:59 End of battle.',
      '2009-04-10 11:49:57 A battle has started.',
      '2009-04-10 12:29:58 End of battle.',
      '2009-04-10 22:39:11 A battle has started.',
      '2009-04-11 06:50:05 The planet owner has changed.',
      '2009-04-11 07:00:17 Public alliance tag set to [<b>-FK-</b>]', //this entry is in both data files, but should only appear once in the DB
      '2009-04-11 08:30:02 End of battle.'
    );
    $result = mysql_query("select e.* from events e inner join planets p on e.planet_id = p.id where p.hyp_id = 626");
    $this->assertEquals(9, mysql_num_rows($result));
    while($row = mysql_fetch_array($result)){
      $this->assertEquals(true, in_array($row['date'] . ' ' . $row['description'], $row_values));
    }
    mysql_free_result($result);
  }
}
?>
