<?php
require_once 'DatabaseTestBase.php';
require_once '../MySqlDatabaseDao.php';
require_once '../Alliance.php';
require_once '../Event.php';
require_once '../Planet.php';
require_once '../Player.php';

/*
Tests the MySQL database DAO. The database must already be running for this test to work.
*/
class MySqlDatabaseDaoTest extends DatabaseTestBase{
  private $dao, $con;
  
  protected function setUp(){
    $this->initDatabase();
    
    $this->dao = new MySqlDatabaseDao($this->host, $this->username, $this->password, $this->db);
    
    $this->con = mysql_connect($this->host, $this->username, $this->password);
    if (!$this->con){
      die('Could not connect: ' + mysql_error());
    }
  }
  
  protected function tearDown(){
    mysql_query("drop database $this->db");
    $this->dao->close();
    mysql_close($this->con);
  }

  public function test(){
    $a = $this->dao->getAlreadyImportedFilesDates();
    $this->assertEquals(0, count($a));
    
    $imported_file_id = $this->dao->addImportedFile('20070410');
    
    $a = $this->dao->getAlreadyImportedFilesDates();
    $this->assertEquals(1, count($a));
    $this->assertEquals('20070410', $a[0]);
    
    //PLAYER==============
    
    $player = new Player('Caulius 827 865 1696451 1 848 4658 848 0 Nuneaton');
    $player_id = $this->dao->addPlayerData($player, $imported_file_id);
    
    $result = mysql_query('select * from players');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($player->name, 'name', $row);
    $this->assertColumn($player->location, 'location', $row);
    mysql_free_result($result);
    
    $result = mysql_query('select * from player_histories');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($player_id, 'player_id', $row);
    $this->assertColumn($imported_file_id, 'imported_file_id', $row);
    $this->assertColumn($player->influ_rank, 'influ_rank', $row);
    $this->assertColumn($player->influ_rank_sc, 'influ_rank_sc', $row);
    $this->assertColumn($player->influ_score, 'influ_score', $row);
    $this->assertColumn($player->hyp_rank, 'hyp_rank', $row);
    $this->assertColumn($player->idr_rank, 'idr_rank', $row);
    $this->assertColumn($player->idr_score, 'idr_score', $row);
    $this->assertColumn($player->idr_rank_sc, 'idr_rank_sc', $row);
    $this->assertColumn($player->sc, 'sc', $row);
    mysql_free_result($result);
    
    //ALLIANCE==============
    
    $alliance = new Alliance(array('-TKC- ;p', 'Ridding the universe of evil!', 'Caulius 5 -4 2 2'));
    $alliance_id = $this->dao->addAllianceData($alliance, $imported_file_id);
    
    $result = mysql_query('select * from alliances');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($alliance->name, 'name', $row);
    $this->assertColumn($alliance->tag, 'tag', $row);
    $this->assertColumn($alliance->description, 'description', $row);
    mysql_free_result($result);
    
    $result = mysql_query('select * from alliance_histories');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($alliance_id, 'alliance_id', $row);
    $this->assertColumn($imported_file_id, 'imported_file_id', $row);
    $this->assertColumn($player_id, 'president_id', $row);
    $this->assertColumn($alliance->avg_x, 'avg_x', $row);
    $this->assertColumn($alliance->avg_y, 'avg_y', $row);
    $this->assertColumn($alliance->nb_planets, 'nb_planets', $row);
    $this->assertColumn($alliance->total_influence, 'total_influence', $row);
    mysql_free_result($result);
    
    //PLANET==============
    
    $planet = new Planet('51 BaC-loves-u-all 0 -5 6 1 2 15183 [-TKC-] 4 7');
    $planet_id = $this->dao->addPlanetData($planet, $imported_file_id);
    
    $result = mysql_query('select * from planets');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($planet->hyp_id, 'hyp_id', $row);
    $this->assertColumn($planet->race, 'race', $row);
    $this->assertColumn($planet->prod_type, 'prod_type', $row);
    mysql_free_result($result);
    
    $result = mysql_query('select * from planet_histories');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($planet_id, 'planet_id', $row);
    $this->assertColumn($imported_file_id, 'imported_file_id', $row);
    $this->assertColumn($planet->name, 'name', $row);
    $this->assertColumn($planet->x, 'x', $row);
    $this->assertColumn($planet->y, 'y', $row);
    $this->assertColumn($planet->gov_system, 'gov_system', $row);
    $this->assertColumn($planet->activity, 'activity', $row);
    $this->assertColumn($alliance_id, 'alliance_id', $row);
    $this->assertColumn($planet->civ_level, 'civ_level', $row);
    $this->assertColumn($planet->planet_size, 'planet_size', $row);
    mysql_free_result($result);
    
    //EVENT==============
    
    $event = new Event('51 BaC-loves-u-all 2007-04-10 06:50:21 The government system has changed to Dictatorial.');
    $event_id = $this->dao->addEventData($event, $imported_file_id);
    
    $result = mysql_query('select * from events');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($imported_file_id, 'imported_file_id', $row);
    $this->assertColumn($planet_id, 'planet_id', $row);
    $this->assertColumn($event->date, 'date', $row);
    $this->assertColumn($event->description, 'description', $row);
    mysql_free_result($result);
    
    //===============================
    
    $imported_file_id = $this->dao->addImportedFile('20070411');
    
    //PLAYER==========
    $player = new Player('Caulius 827 865 1696451 1 848 4658 848 0 Mars');
    $player_id = $this->dao->addPlayerData($player, $imported_file_id);
    
    $result = mysql_query('select * from players');
    $this->assertEquals(1, mysql_num_rows($result)); //should have updated the entry
    $row = mysql_fetch_array($result);
    $this->assertColumn($player->name, 'name', $row);
    $this->assertColumn($player->location, 'location', $row); 
    mysql_free_result($result);
    
    $result = mysql_query('select * from player_histories');
    $this->assertEquals(2, mysql_num_rows($result));
    mysql_free_result($result);
    
    //ALLIANCE==============
    
    $alliance = new Alliance(array('-TKC- ;p', 'Defeating tyrants whereever they lie!', 'Caulius 5 -4 2 2'));
    $alliance_id = $this->dao->addAllianceData($alliance, $imported_file_id);
    
    $result = mysql_query('select * from alliances');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($alliance->name, 'name', $row);
    $this->assertColumn($alliance->tag, 'tag', $row);
    $this->assertColumn($alliance->description, 'description', $row);
    mysql_free_result($result);
    
    $result = mysql_query('select * from alliance_histories');
    $this->assertEquals(2, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    mysql_free_result($result);
    
    //PLANET==============
    
    $planet = new Planet('51 NewName 0 -5 6 1 2 15183 [-TKC-] 4 7');
    $planet_id = $this->dao->addPlanetData($planet, $imported_file_id);
    
    $result = mysql_query('select * from planets');
    $this->assertEquals(1, mysql_num_rows($result));
    $row = mysql_fetch_array($result);
    $this->assertColumn($planet->hyp_id, 'hyp_id', $row);
    $this->assertColumn($planet->race, 'race', $row);
    $this->assertColumn($planet->prod_type, 'prod_type', $row);
    mysql_free_result($result);
    
    $result = mysql_query('select * from planet_histories');
    $this->assertEquals(2, mysql_num_rows($result));
    mysql_free_result($result);
    
    //EVENT==============
    
    $event = new Event('51 BaC-loves-u-all 2007-04-11 07:11:48 A battle has started.');
    $event_id = $this->dao->addEventData($event, $imported_file_id);
    
    $result = mysql_query('select * from events');
    $this->assertEquals(2, mysql_num_rows($result));
    mysql_free_result($result);
  }
}
?>
