<?php
require_once 'PHPUnit/Framework.php';
require_once '../Planet.php';

/*
Tests the Planet class.
*/
class PlanetTest extends PHPUnit_Framework_TestCase{
  public function testWithAlliance(){
    $planet = new Planet('51 BaC-loves-u-all 0 -5 6 1 2 15183 [BaC] 4 7');
    $this->assertEquals(51, $planet->hyp_id);
    $this->assertEquals('BaC-loves-u-all', $planet->name);
    $this->assertEquals(0, $planet->gov_system);
    $this->assertEquals(-5, $planet->x);
    $this->assertEquals(6, $planet->y);
    $this->assertEquals(1, $planet->race);
    $this->assertEquals(2, $planet->prod_type);
    $this->assertEquals(15183, $planet->activity);
    $this->assertEquals('BaC', $planet->public_tag);
    $this->assertEquals(4, $planet->civ_level);
    $this->assertEquals(7, $planet->planet_size);
  }
  
  public function testWithoutAlliance(){
    $planet = new Planet('51 BaC-loves-u-all 0 -5 6 1 2 15183 [] 4 7');
    $this->assertEquals(51, $planet->hyp_id);
    $this->assertEquals('BaC-loves-u-all', $planet->name);
    $this->assertEquals(0, $planet->gov_system);
    $this->assertEquals(-5, $planet->x);
    $this->assertEquals(6, $planet->y);
    $this->assertEquals(1, $planet->race);
    $this->assertEquals(2, $planet->prod_type);
    $this->assertEquals(15183, $planet->activity);
    $this->assertEquals(null, $planet->public_tag);
    $this->assertEquals(4, $planet->civ_level);
    $this->assertEquals(7, $planet->planet_size);
  }
}
?>
